/**
common-scripts.js
MOTOROLA_CONFIDENTIAL_PROPRIETARY
------------------------------------------------------------------------------------------
                        Motorola Confidential Proprietary
                Copyright 2009 Motorola, Inc. All Rights Reserved.

Internal Revision History:

Modification Tracking

        Author                Date           CR         Description of Changes
-------------------------   ------------ ---------- ----------------------------------------
     atila.andrade          2009-11-23      45701       Initial Version
     
**/

// =================================================================================================
// 
// DASHBOARD 
// 
// =================================================================================================

var ROOT_USR = "root";
var ADMIN_USR = "admin";
//var _userName = null;
// GLOBAL - config resources available
_deviceConfig = null;
//  Check if the user is a Operator or a Subscriber and show the correspondent content
//_userCookie = readCookie('userData');

// Show Flex App
$('#idToolboxButton').click(function() {
    // Hide scrollbar when necessary
    document.body.style.overflow = "hidden";
    // Force scroll page to top
    document.body.scrollTop = 0;
    // When the Toolbox link is clicked show the Flex App to user
    $('#flex-app').show();	
});

// Close Flex App
function closeToolbox() {
	// Reload current page when Toolbox is closed
	location.reload();
};

// Get the current language based on 
// html-tag previously added
function getCurrentLanguage()
{
    return $('#switch img').attr('id');
}

// Send current user language to Flex App
function getCurrentLanguageTable() {
    // Get and return the current idiom of the user
    var currentLocale = getCurrentLanguage();
    
    if (currentLocale == null)
    {
        // A gateway page is being opened and
        // the language previously loaded was not
        // identified. 
        // ** DEFAULT_ID_LANGUAGE will be loaded.
        importLangScript(DEFAULT_ID_LANGUAGE, DEFAULT_ID_LANGUAGE + '.js');
        currentLocale = DEFAULT_ID_LANGUAGE;
    }
  
    return this[currentLocale];
};

function loadApp()
{
    $.ajax ({
        type:"POST",
        url:"config/gui_configuration.xml",
        dataType:"xml",
        error: function(){ 
            loadResources(null); 
        },
        success: function(xmlResponse){ 
            loadResources(xmlResponse); 
        }
    });
}

// PUBLIC
// Loads all resources needs to show the dynamic content
function loadResources(xmlResponse)
{
    if (xmlResponse != null)
    {
        _deviceConfig = parserXmlConfig(xmlResponse);
    }
    // Load the menu HTML code dynamically
    loadMenu();
    // Load the footer content dynamically
    loadFooter();
    // Load the content page. This function is implemented for gateway and legacy script (overhide)
    loadContentPage();
    // Load operator logo
    //loadOperatorLogo();
    // Load operator (button) access
    loadOperatorBtn();
}

// =================================================================================================
// 
// CONFIGURATION FILE SETTINGS
// 
// =================================================================================================

// Parser xml config. Build a object with the device properties.

// Sample Object

// localConfig = {
//      operator_logo_path: images/<image_name>.gif
//      telephone: true,
//      battery:   false,
//      dashBoard: false
// };
function parserXmlConfig(xmlResponse)
{
    var config = {};
    config.operator_logo_path = ($(xmlResponse).find('operator_logo_path').text().toLowerCase());
    config.operatorAccess = ($(xmlResponse).find('operator_access').text().toLowerCase() === 'true');
    config.telephone = ($(xmlResponse).find('telephone_support').text().toLowerCase() === 'true');
    config.battery = ($(xmlResponse).find('battery_support').text().toLowerCase() === 'true');
    config.dashBoard = ($(xmlResponse).find('widgets_support').text().toLowerCase() === 'true');
    config.gateway = ($(xmlResponse).find('gateway_support').text().toLowerCase() === 'true');
    return config;
}

// Loading operator logo
function loadOperatorLogo()
{
    if ( _deviceConfig != null || (!_deviceConfig.operator_logo_path) )
    {
        // in case of the image doesn't exist, no image will be loaded
        $('#company-logo span').css('background','url('+ _deviceConfig.operator_logo_path +') no-repeat');
    }
    else
    {
        // No operator logo will be displayed
    }

}

// Loading operator (button) access
function loadOperatorBtn()
{
    if ( _deviceConfig != null && (!_deviceConfig.operatorAccess) )
    {
        // Remove the link 'Operator Access'
        $('.operator-access').remove();    
    }
}

// Load menu dynamically
function loadMenu()
{
	$("#myjquerymenu").load('menu.html',function() 
  {
    var menuSelector = '#menu';
    $(menuSelector).hide(); 
    
    // Register the click events to latest section
    latestClickEvents();
          
    // If the _deviceConfig wasn't loaded or just cable modem resource is available...
    if (  _deviceConfig == null   || 
        (!_deviceConfig.telephone && 
         !_deviceConfig.battery   && 
         !_deviceConfig.gateway) 
       )
    {
      $('.telephone-section').remove();
      $('.gateway-section').remove();
      $('.battery-section').remove();
      $('#help-section .submenu').remove();
    }
    else
    {
      // If telephone resource is available...
      if (!_deviceConfig.telephone)
      {
        $('.telephone-section').remove();        
      }
      // If gateway resource is available...
      if (!_deviceConfig.gateway)
      {
        $('.gateway-section').remove();
      }
      // If battery resource is available...
      if (!_deviceConfig.battery)
      {
        $('.battery-section').remove();
      }
    }

    // Information added based on user profile (only if there is a valid 'session')
    //advancedUserMenu();
    // Hide main container
    $('#container, #footer').hide();	
    // Translate the menu content
    updateContent(menuSelector); 
    // After the structure changes....shows the menu 
    $(menuSelector).show();
    // Apply a class (.active) to the current menu item. Used to focus the current menu item.
    selectCurrentMenuItem();
    // Show main container
    $('#container, #footer').show();

    // building menu and submenu layers
    buildMenu();
    selectCurrentMenuItem();
	if(_CustomerId == "mobistar")AddLogo();
	});
	
	
  
}
function AddLogo()
{
	$("h1").attr("class", "right");
	//var logostr ='<div class="left"><a href="index.html" class="block indent" id="idmobistar"></a></div>';
	//$('#container').css({'padding-left':'40px', 'position':'absolute', 'left':'170px'});				   
	//$(logostr).insertBefore("#container");

}

// Load footer page dynamically
function loadFooter()
{
    if (_deviceConfig != null && _deviceConfig.dashBoard)
    {
        $('#footer a').show();
    }
    
}

// Verify if there is a valid user cookie and show the advanced menu itens
function advancedUserMenu() {
    // If the user is a operator
    if(_userCookie == 'root') {
    
      var menuCableModem = $('#menu .modem-section .submenu');
      var menuTelephone  = $('#menu .telephone-section .submenu');
      
      // Put "Provisioning" submenu item in "Cable Modem" menu item
    	$('<li><a href="modem_provisioning.html" class="dynamic" id="idProvisioning">Provisioning</a></li>')
    	.appendTo(menuCableModem);
        
      // Put "Provisioning" submenu item in "Telephone" menu item
    	$('<li><a href="telephone_provisioning.html" class="dynamic" id="idProvisioning">Provisioning</a></li>')
    	.appendTo(menuTelephone);
		
      // Put "Configuration" submenu item in "Telephone" menu item
    	$('<li><a href="telephone_configuration.html" class="dynamic" id="idConfiguration">Configuration</a></li>')
    	.appendTo(menuTelephone);
    }
} 

// Add properties to submenu itens
function subMenu() {
    $('#menu li,.submenu').hover(
    function() {
        // Change the 'position' css property to 'static'
        $('#tabs a').css('position','static');
        // Set 'active' css class to selected elements
        $(this).addClass('active');
        // Set an opacity effect and show submenu itens
        $(this).find('.submenu').animate({opacity: "0.8"}, 100).show();
    }, function() {
        // Hide submenu itens
        $(this).find('.submenu').hide();
        // Remove 'active' css class to selected elements
        $(this).removeClass('active');
    });
}

// Apply a class to the menu item that is currently being used
function selectCurrentMenuItem()
{
    var bodyId = $('body').attr('id');

    switch(bodyId)
    {
		/* CBN_S - 20131007 - Gary - Add summary page for KD. */
        case "summary":
           $('#menu #idsummary').addClass('active');
        break;
		/* CBN_E - 20131007 - Gary - Add summary page for KD. */
        case "cable-modem":
           $('#menu #idCableModem').addClass('active');
        break;
        
        case "telephone":
           $('#menu #idTelephone').addClass('active');
        break;
        
        case "battery":
           $('#menu #idBattery').addClass('active');
        break;
        
        case "help":
           $('#menu #idHelp').addClass('active');
        break;
		
        case "gateway":
           $('#menu #idGateway').addClass('active');
        break;
    }
}

// =================================================================================================
// 
// COOKIE FUNCTIONS
// 
// =================================================================================================

/// <summary>
/// Functions used to create, read and erase cookies.
/// </summary>
///
/// <param name="sName">The name of the cookie.</param>
/// <param name="sValue">The value(string) stored in a cookie.</param>
/// <param name="days">Validity of a cookie in days</param>

// Create Cookie
function createCookie(sName,sValue,days) {
    if (days) {
        var date = new Date();
        date.setTime(date.getTime()+(days*24*60*60*1000));
        var expires = "; expires="+date.toGMTString();
    }
    else var expires = "";
    document.cookie = sName+"="+sValue+expires+"; path=/";
};

// Read Cookie
function readCookie(sName) {
    var sNameEQ = sName + "=";
    var ca = document.cookie.split(';');
    for(var i=0;i < ca.length;i++) {
        var c = ca[i];
        while (c.charAt(0)==' ') c = c.substring(1,c.length);
        if (c.indexOf(sNameEQ) == 0) {
            string_match = c.substring(sNameEQ.length,c.length);
            if (sName == "userData"){
                _userName = string_match;
                if (string_match == ROOT_USR) {
                    return _userName;
                }
                else if (string_match == ADMIN_USR) {
                    return _userName;
                }
                else
                {
                    return null;
                }
            }
            return string_match;
        }
    }
    return null;
};

// Erase Cookie
function eraseCookie(sName) {
    createCookie(sName, "", -1);
}

// Get GET variable from url, qs is the url.
function getQueryParams(qs) {
    qs = qs.split("+").join(" ");
    var params = {},
        tokens,
        re = /[?&]?([^=]+)=([^&]*)/g;

    while (tokens = re.exec(qs)) {
        params[decodeURIComponent(tokens[1])]
            = decodeURIComponent(tokens[2]);
    }

    return params;
}
